import Vuex from 'vuex'
import Vue from 'vue'
import ax from './api'

Vue.use(Vuex)

const store = new Vuex.Store({
  state: {
    token: '',
    loggedIn: false,
    username: ''
  },
  mutations: {
    'LOGIN': function (state, creds) {
      state.token = creds.token
      state.loggedIn = true
      state.username = creds.username
    },
    'LOGOUT': function (state) {
      state.token = ''
      state.loggedIn = false
    }
  },
  actions: {
    async getToken (store, credentials) {
      const response = await ax.post('api-token-auth/', credentials)
      store.commit('LOGIN', {
        token: response.data.token,
        username: credentials.username
      })
      ax.defaults.headers.common['Authorization'] = 'JWT ' + response.data.token
    },
    logout (store) {
      store.commit('LOGOUT')
    }
  }
})

export default store
